/* Problem URL: https://codeforces.com/gym/101845/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;

struct pt {
    ll x, y;

    pt() = default;
    pt(ll x, ll y): x(x), y(y) {}

    friend istream &operator >> (istream &is, pt &a) {
        is >> a.x >> a.y;
        return is;
    }

    ll operator * (pt b) {
        return x * b.x + y * b.y;
    }

    ll operator ^ (pt b) {
        return x * b.y - y * b.x;
    }

    pt operator - (pt b) {
        return pt(x - b.x, y - b.y);
    }
};

ll sarea2(pt a, pt b, pt c)
{
    return (b - a) ^ (c - a);
}

int ccw(pt a, pt b, pt c)
{
    ll r = sarea2(a, b, c);
    return (r > 0) - (r < 0);
}

void pre()
{

}

#define TEST 0

void solve()
{
    int n, m;
    cin >> n >> m;

    V<pt> pol(n);
    cin >> pol;

    vl pref(n * 3);
    nrep(i, 1, n * 3) {
        pref[i] = pref[i - 1] + sarea2(pt(0, 0), pol[(i - 1) % n], pol[i % n]);
    }

    ll ans = 0;
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--, r--;

        if (l > r) {
            swap(l, r);
        }

        if ((l + 1) % n == r) {
            continue;
        }

        int l2 = r;
        int r2 = l + n;

        ll ar1 = abs(sarea2(pt(0, 0), pol[r], pol[l]) + pref[r] - pref[l]);
        ll ar2 = abs(pref[r2] - pref[l2] + sarea2(pt(0, 0), pol[r2 % n], pol[l2 % n]));

        rmax(ans, min(ar1, ar2));
    }

    cout << ans / 2.0 << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
